
package net.mcreator.theawesomeexperience.entity;

import net.minecraftforge.registries.ForgeRegistries;
import net.minecraftforge.network.PlayMessages;
import net.minecraftforge.network.NetworkHooks;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraftforge.api.distmarker.Dist;

import net.minecraft.world.phys.EntityHitResult;
import net.minecraft.world.phys.BlockHitResult;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.entity.projectile.ItemSupplier;
import net.minecraft.world.entity.projectile.AbstractArrow;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.entity.EntityType;
import net.minecraft.util.RandomSource;
import net.minecraft.sounds.SoundSource;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.network.protocol.game.ClientGamePacketListener;
import net.minecraft.network.protocol.Packet;

import net.mcreator.theawesomeexperience.procedures.SandoplentyStaffProjectileHitsLivingEntityProcedure;
import net.mcreator.theawesomeexperience.procedures.SandoplentyStaffProjectileHitsBlockProcedure;
import net.mcreator.theawesomeexperience.init.TheAwesomeExperienceModEntities;
import net.mcreator.theawesomeexperience.init.TheAwesomeExperienceModBlocks;

@OnlyIn(value = Dist.CLIENT, _interface = ItemSupplier.class)
public class SandoplentyStaffEntity extends AbstractArrow implements ItemSupplier {
	public SandoplentyStaffEntity(PlayMessages.SpawnEntity packet, Level world) {
		super(TheAwesomeExperienceModEntities.SANDOPLENTY_STAFF.get(), world);
	}

	public SandoplentyStaffEntity(EntityType<? extends SandoplentyStaffEntity> type, Level world) {
		super(type, world);
	}

	public SandoplentyStaffEntity(EntityType<? extends SandoplentyStaffEntity> type, double x, double y, double z, Level world) {
		super(type, x, y, z, world);
	}

	public SandoplentyStaffEntity(EntityType<? extends SandoplentyStaffEntity> type, LivingEntity entity, Level world) {
		super(type, entity, world);
	}

	@Override
	public Packet<ClientGamePacketListener> getAddEntityPacket() {
		return NetworkHooks.getEntitySpawningPacket(this);
	}

	@Override
	@OnlyIn(Dist.CLIENT)
	public ItemStack getItem() {
		return new ItemStack(Blocks.SAND);
	}

	@Override
	protected ItemStack getPickupItem() {
		return new ItemStack(TheAwesomeExperienceModBlocks.MANA_ORBOID.get());
	}

	@Override
	protected void doPostHurtEffects(LivingEntity entity) {
		super.doPostHurtEffects(entity);
		entity.setArrowCount(entity.getArrowCount() - 1);
	}

	@Override
	public void onHitEntity(EntityHitResult entityHitResult) {
		super.onHitEntity(entityHitResult);
		SandoplentyStaffProjectileHitsLivingEntityProcedure.execute(this.level(), this.getX(), this.getY(), this.getZ());
	}

	@Override
	public void onHitBlock(BlockHitResult blockHitResult) {
		super.onHitBlock(blockHitResult);
		SandoplentyStaffProjectileHitsBlockProcedure.execute(this.level(), blockHitResult.getBlockPos().getX(), blockHitResult.getBlockPos().getY(), blockHitResult.getBlockPos().getZ());
	}

	@Override
	public void tick() {
		super.tick();
		if (this.inGround)
			this.discard();
	}

	public static SandoplentyStaffEntity shoot(Level world, LivingEntity entity, RandomSource random, float power, double damage, int knockback) {
		SandoplentyStaffEntity entityarrow = new SandoplentyStaffEntity(TheAwesomeExperienceModEntities.SANDOPLENTY_STAFF.get(), entity, world);
		entityarrow.shoot(entity.getViewVector(1).x, entity.getViewVector(1).y, entity.getViewVector(1).z, power * 2, 0);
		entityarrow.setSilent(true);
		entityarrow.setCritArrow(true);
		entityarrow.setBaseDamage(damage);
		entityarrow.setKnockback(knockback);
		world.addFreshEntity(entityarrow);
		world.playSound(null, entity.getX(), entity.getY(), entity.getZ(), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.lightning_bolt.thunder")), SoundSource.PLAYERS, 1, 1f / (random.nextFloat() * 0.5f + 1) + (power / 2));
		return entityarrow;
	}

	public static SandoplentyStaffEntity shoot(LivingEntity entity, LivingEntity target) {
		SandoplentyStaffEntity entityarrow = new SandoplentyStaffEntity(TheAwesomeExperienceModEntities.SANDOPLENTY_STAFF.get(), entity, entity.level());
		double dx = target.getX() - entity.getX();
		double dy = target.getY() + target.getEyeHeight() - 1.1;
		double dz = target.getZ() - entity.getZ();
		entityarrow.shoot(dx, dy - entityarrow.getY() + Math.hypot(dx, dz) * 0.2F, dz, 2f * 2, 12.0F);
		entityarrow.setSilent(true);
		entityarrow.setBaseDamage(6);
		entityarrow.setKnockback(4);
		entityarrow.setCritArrow(true);
		entity.level().addFreshEntity(entityarrow);
		entity.level().playSound(null, entity.getX(), entity.getY(), entity.getZ(), ForgeRegistries.SOUND_EVENTS.getValue(new ResourceLocation("entity.lightning_bolt.thunder")), SoundSource.PLAYERS, 1,
				1f / (RandomSource.create().nextFloat() * 0.5f + 1));
		return entityarrow;
	}
}
